set fn [lindex $argv 0]
set f [open $fn r]
fconfigure $f -translation binary

proc wr {i blob} {
 global fn
 set bl [open $fn.b$i w]
 fconfigure $bl -translation binary
 puts -nonewline $bl $blob
 close $bl
}

set i 0
while {![eof $f]} {
 if {$i == 3} {
  set blob [read $f $len]
  wr $i $blob
 }
 set l [read $f 4]
 set ll [string length $l]
 if {$ll == 0} {
  puts "EOF"
  break
 } elseif {$ll != 4} {
  puts stderr "error: incomplete len $ll/4"
  break
 }
 binary scan $l iu len
 puts [format "len_hex=0x%x len_dec=%u addr=0x%x" $len $len [tell $f]]
 set blob [read $f $len]
 set ll [string length $blob]
 if {[string length $blob] != $len} {
  puts stderr "error: incomplete  blob $ll/$len"
  break
 }
 wr $i $blob
 incr i
}
